%define inst_pref	/usr

%define cross_compile 0
%define make_gdbserver_for_mips 0 
%{?_with_crosscompile: %{expand: %%define cross_compile 1}}

%{?_make_gdbserver_for_mips: %{expand: %%define make_gdbserver_for_mips 1}}
%{?_make_gdbserver_for_mips: %{expand: %%define cross_compile 1}}
%{?_inst_pref: %{expand: %%define inst_pref %{_inst_pref}}}



#set env

%if %{make_gdbserver_for_mips}



%define make_flags CC=%{__cc} CXX=%{__cxx} AR=%{__ar} AS=%{__as} LD=%{__ld} NM=%{__nm} RANLIB=%{__ranlib} CC_FOR_TARGET=%{__cc} GCC_FOR_TARGET=%{__cc} CXX_FOR_TARGET=%{__cxx} AR_FOR_TARGET=%{__ar} AS_FOR_TARGET=%{__as} LD_FOR_TARGET=%{__ld} NM_FOR_TARGET=%{__nm} RANLIB_FOR_TARGET=%{__ranlib} HOST_CC=cc CFLAGS_FOR_TARGET="$RPM_OPT_FLAGS -pipe" CFLAGS_FOR_BUILD="-O -pipe" CFLAGS="$RPM_OPT_FLAGS -pipe" CXXFLAGS="$RPM_OPT_FLAGS -pipe" 



%else



%define make_flags CC_FOR_TARGET=%{__cc} GCC_FOR_TARGET=%{__cc} CXX_FOR_TARGET=%{__cxx} AR_FOR_TARGET=%{__ar} AS_FOR_TARGET=%{_as} LD_FOR_TARGET=%{__ld} NM_FOR_TARGET=%{__nm} RANLIB_FOR_TARGET=%{__ranlib} HOST_CC=cc CFLAGS_FOR_TARGET="$RPM_OPT_FLAGS -pipe" CFLAGS_FOR_BUILD="-O -pipe" CFLAGS="$RPM_OPT_FLAGS -pipe" CXXFLAGS="$RPM_OPT_FLAGS -pipe"



%endif






%define cvsdate 5.2.90_2002-10-03-cvs

Summary: A GNU source-level debugger for C, C++ and Fortran.
Name: mips-linux-gdb
Version: 5.2.90
Release: 0.2.2.niisi
Copyright: GPL
Group: Development/Debuggers
Source: gdb-%{cvsdate}.tar.bz2
Patch1000: gdb-include.patch
Patch1002: gdb-static.patch
Patch1004: gdb-break.patch
Patch1006: gdb-thread.patch
Buildroot: %{_tmppath}/%{name}-%{version}-root
BuildRequires: ncurses-devel glibc-devel gcc make gzip
Prereq: info

%description
Gdb is a full featured, command driven debugger. Gdb allows you to
trace the execution of programs and examine their internal state at
any time.  Gdb works for C and C++ compiled with the GNU C compiler
gcc.

If you are going to develop C and/or C++ programs and use the GNU gcc
compiler, you may want to install gdb to help you debug your
programs.


%package  -n gdbserver
Summary: gdbserver for mips-linux
Group: Development/Tools

%description -n gdbserver
Gdbserver for mips-linux

%prep
%setup -q -n gdb-%{cvsdate}

%patch1000 -p0 -b .include
%patch1002 -p0 -b .static
%patch1004 -p0 -b .break
%patch1006 -p0 -b .thread

cat > gdb/version.in << _FOO
%{version}-%{release} (%{cvsdate})
_FOO

%build

# if RPM_BUILD_NCPUS unset, set it
if [ -z "$RPM_BUILD_NCPUS" ] ; then
  if [ -x /usr/bin/getconf ] ; then
    RPM_BUILD_NCPUS=$(/usr/bin/getconf _NPROCESSORS_ONLN)
    if [ $RPM_BUILD_NCPUS -eq 0 ]; then 
      RPM_BUILD_NCPUS=1
    fi
  else
    RPM_BUILD_NCPUS=1
  fi
fi
RPM_BUILD_NCPUS=`expr $RPM_BUILD_NCPUS + $RPM_BUILD_NCPUS`

 
%if %{make_gdbserver_for_mips}

RPM_OPT_FLAGS="-pipe -O2 -fomit-frame-pointer"
export	CC=%{__cc} \
	CXX=%{__cxx} \
	AR=%{__ar} \
	AS=%{__as} \
	LD=%{__ld} \
	NM=%{__nm} \
	STRIP=%{__strip} \
	RANLIB=%{__ranlib}

export	CC_FOR_TARGET=%{__cc} \
	GCC_FOR_TARGET=%{__cc} \
	CXX_FOR_TARGET=%{__cxx} \
	AR_FOR_TARGET=%{__ar} \
	AS_FOR_TARGET=%{__as} \
	LD_FOR_TARGET=%{__ld} \
	NM_FOR_TARGET=%{__nm} \
	STRIP_FOR_TARGET=%{__strip} \
	RANLIB_FOR_TARGET=%{__ranlib} \
	HOST_CC=cc \
	CFLAGS_FOR_TARGET="$RPM_OPT_FLAGS -pipe" \
	CFLAGS_FOR_BUILD="-O -pipe" \
	CFLAGS="$RPM_OPT_FLAGS -pipe" \
	CXXFLAGS="$RPM_OPT_FLAGS -pipe" \
	ac_cv_func_mmap_fixed_mapped=yes \
	gdb_cv_printf_has_long_long=yes \
	gdb_cv_printf_has_long_double=yes \
	gdb_cv_scanf_has_long_double=yes

CROSS_BUILD_FLAGS="--build=%{_build_alias}"
%else


#RPM_OPT_FLAGS="-pipe -O2 -fomit-frame-pointer"
export	CC=gcc \
	CXX=c++ \
	AR=ar \
	AS=as \
	LD=ld \
	NM=nm \
	STRIP=strip \
	RANLIB=ranlib

export	CC_FOR_TARGET=%{__cc} \
	GCC_FOR_TARGET=%{__gcc} \
	CXX_FOR_TARGET=%{__cxx} \
	AR_FOR_TARGET=%{__ar} \
	AS_FOR_TARGET=%{__as} \
	LD_FOR_TARGET=%{__ld} \
	NM_FOR_TARGET=%{__nm} \
	STRIP_FOR_TARGET=%{__strip} \
	RANLIB_FOR_TARGET=%{__ranlib} \
	HOST_CC=cc \
	CFLAGS_FOR_TARGET="$RPM_OPT_FLAGS -pipe" \
	CFLAGS_FOR_BUILD="-O -pipe" \
	CFLAGS="$RPM_OPT_FLAGS -pipe" \
	CXXFLAGS="$RPM_OPT_FLAGS -pipe" \
	ac_cv_func_mmap_fixed_mapped=yes \
	gdb_cv_printf_has_long_long=yes \
	gdb_cv_printf_has_long_double=yes \
	gdb_cv_scanf_has_long_double=yes

CROSS_BUILD_FLAGS="--build=%{_build_alias}"

%endif

export CFLAGS="$RPM_OPT_FLAGS"

rm -fr dejagnu tcl expect 

%if %{make_gdbserver_for_mips}
export LDFLAGS="-static"
./configure  --prefix=/usr --sysconfdir=/etc --mandir=/usr/share/man --infodir=/usr/share/info \
    $CROSS_BUILD_FLAGS --disable-gdbtk %{_arch}-%{_vendor}-linux 
%else


./configure  --target=mips-linux --prefix=%{inst_pref}  --sysconfdir=/etc --mandir=usr/share/man --infodir=%{inst_pref}/share/info \
    $CROSS_BUILD_FLAGS --disable-gdbtk %{_build_arch}-%{_build_vendor}-linux

%endif
%if %{make_gdbserver_for_mips}
	%if %{cross_compile}
		make %{make_flags} -j$RPM_BUILD_NCPUS
		%ifnarch alpha
			make -C gdb/gdbserver %{make_flags} -j$RPM_BUILD_NCPUS
		%endif
	%else
		make -j$RPM_BUILD_NCPUS
		%ifnarch alpha
			make -C gdb/gdbserver -j$RPM_BUILD_NCPUS
		%endif
	%endif
	make info CFLAGS=-O
	cp gdb/NEWS .

%else


	make %{make_flags} -j$RPM_BUILD_NCPUS
	make info CFLAGS=-O
	cp gdb/NEWS .


%endif


%install

rm -rf $RPM_BUILD_ROOT


%if %{make_gdbserver_for_mips}

	echo mips branch
	%makeinstall %{make_flags} \
	infodir=$RPM_BUILD_ROOT/${_infodir} prefix=$RPM_BUILD_ROOT/usr
	%ifnarch alpha
		%makeinstall -C gdb/gdbserver %{make_flags} \
			infodir=$RPM_BUILD_ROOT/${_infodir} prefix=$RPM_BUILD_ROOT/usr
	%endif

	%ifnarch alpha
# 		Install gdbreplay.
		install -m 755 gdb/gdbserver/gdbreplay $RPM_BUILD_ROOT/usr/bin
	%endif

%else  

	echo gdb branch
	make install %{make_flags} \
		infodir=$RPM_BUILD_ROOT/%{inst_pref}/share/info prefix=$RPM_BUILD_ROOT/%{inst_pref}   \
mandir=$RPM_BUILD_ROOT/usr/share/man
%endif

%if %{make_gdbserver_for_mips}
# The above is broken, do this for now:
mkdir -p $RPM_BUILD_ROOT/%{_infodir}
cp `find -name "*.info*"` $RPM_BUILD_ROOT/%{_infodir}

rm -f $RPM_BUILD_ROOT%{_infodir}/dir $RPM_BUILD_ROOT%{_infodir}/dir.info* 

#These are part of binutils

rm -f $RPM_BUILD_ROOT%{_infodir}/bfd* $RPM_BUILD_ROOT%{_infodir}/standard*
rm -rf $RPM_BUILD_ROOT/usr/include/  $RPM_BUILD_ROOT/usr/lib/lib{bfd*,opcodes*}

gzip -9f $RPM_BUILD_ROOT%{_infodir}/* 

%else

# The above is broken, do this for now:
mkdir -p $RPM_BUILD_ROOT/%{inst_pref}/share/info
cp `find -name "*.info*"` $RPM_BUILD_ROOT/%{inst_pref}/share/info

rm -f $RPM_BUILD_ROOT/%{inst_pref}/share/info/dir $RPM_BUILD_ROOT/%{inst_pref}/share/info/dir.info* 

#These are part of binutils

rm -f $RPM_BUILD_ROOT/%{inst_pref}/share/info/bfd* $RPM_BUILD_ROOT/%{inst_pref}/share/info/standard*
rm -rf $RPM_BUILD_ROOT/%{inst_pref}/include/  $RPM_BUILD_ROOT/%{inst_pref}/lib/lib{bfd*,opcodes*}

gzip -9f $RPM_BUILD_ROOT/%{inst_pref}/share/info/* 

%endif
%if %{make_gdbserver_for_mips}
#strip by hand and exit
%{__strip}  $RPM_BUILD_ROOT/usr/bin/gdbserver
%{__strip}  $RPM_BUILD_ROOT/usr/bin/gdbreplay
exit 0
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%if %{make_gdbserver_for_mips}
	/sbin/install-info %{_infodir}/gdb.info %{_infodir}/dir
	/sbin/install-info %{_infodir}/mmalloc.info.gz %{_infodir}/dir
	/sbin/install-info %{_infodir}/stabs.info.gz %{_infodir}/dir
%else

	/sbin/install-info %{inst_pref}/share/info/gdb.info %{inst_pref}/share/info/dir
	/sbin/install-info %{inst_pref}/share/info/mmalloc.info.gz %{inst_pref}/share/info/dir
	/sbin/install-info %{inst_pref}/share/info/stabs.info.gz %{inst_pref}/share/info/dir

%endif
%preun
%if %{make_gdbserver_for_mips}
if [ $1 = 0 ]; then
    /sbin/install-info --delete %{_infodir}/gdb.info.gz %{_infodir}/dir
    /sbin/install-info --delete %{_infodir}/mmalloc.info.gz %{_infodir}/dir
    /sbin/install-info --delete %{_infodir}/stabs.info.gz %{_infodir}/dir
fi
%else

if [ $1 = 0 ]; then
    /sbin/install-info --delete %{inst_pref}/share/info/gdb.info.gz %{inst_pref}/share/info/dir
    /sbin/install-info --delete %{inst_pref}/share/info/mmalloc.info.gz %{inst_pref}/share/info/dir
    /sbin/install-info --delete %{inst_pref}/share/info/stabs.info.gz %{inst_pref}/share/info/dir
fi

%endif

%if %{make_gdbserver_for_mips} == 0
%files
%defattr(-,root,root)
#%doc COPYING COPYING.LIB README NEWS
%{inst_pref}/bin/mips-linux-gdb
%{inst_pref}/bin/mips-linux-run
#%{inst_pref}/share/*

/usr/share/man/man1/*
%{inst_pref}/share/info/gdb.info*
%{inst_pref}/share/info/stabs.info*
%{inst_pref}/share/info/mmalloc.info*
%endif

%if %{make_gdbserver_for_mips}
%files -n gdbserver
%defattr(-,root,root)
/usr/bin/gdbserver
/usr/bin/gdbreplay
%{_mandir}/man1/gdbserver*
%endif

# don't include the files in include, they are part of binutils
 
%changelog
* Thu Sep 2  2004 Sergey Rogozhkin
- (0.2.2.niisi) Set default files owner/group to root:root in package gdbserver

* Wed Mar 31 2004 Sergey Rogozhkin
- Define inst_prefix as /usr by default
- Remove /lib/* from filelist
